package ru.dbotthepony.mc.prng.mixin;

import net.minecraft.util.RandomSource;
import net.minecraft.world.level.levelgen.LegacyRandomSource;
import net.minecraft.world.level.levelgen.WorldgenRandom;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;

@Mixin(WorldgenRandom.class)
public abstract class WorldgenRandomMixin {
	@Overwrite
	public static RandomSource seedSlimeChunk(int chunkX, int chunkZ, long levelSeed, long salt) {
		return new LegacyRandomSource(
			levelSeed
				+ (long)(chunkX * chunkX * 4987142)
				+ (long)(chunkX * 5947611)
				+ (long)(chunkZ * chunkZ) * 4392871L
				+ (long)(chunkZ * 389711)
				^ salt
		);
	}
}
